#pragma once

typedef unsigned int DWORD;
typedef unsigned short WORD;
typedef unsigned char BYTE;

const DWORD TIMFLAG    = 0x00000010;
const DWORD _4BPPFLAG   = 0x00000008;
const DWORD _4BPPNCFLAG = 0x00000000; // No CLUT
const DWORD _8BPPFLAG   = 0x00000009;
const DWORD _8BPPNCFLAG = 0x00000001; // No CLUT
const DWORD _16BPPFLAG  = 0x00000002;

typedef struct TIM
{
	DWORD ImageType;
	void* FirstHeader;
	void* Clut;
	void* SecondHeader;
	void* Image;
} TIM;

typedef struct TIMCLUTHEADER1 // 4BPP 8BPP
{
	DWORD TimId;
	DWORD BppId;
	DWORD ClutSize;
	WORD  PaletteOrgX;
	WORD  PaletteOrgY;
	WORD  ClutColors;
	WORD  ClutCount;
} TIMCLUTHEADER1;

typedef struct TIMCLUTHEADER2 // 4BPP 8BPP
{
	DWORD ImageDataSize;
	WORD  ImageOrgX;
	WORD  ImageOrgY;
	WORD  ImageWidth;
	WORD  ImageHeight;
} TIMCLUTHEADER2;

typedef struct TIMLINEARHEADER // 16BPP 24BPP
{
	DWORD TimId;
	DWORD BppId;
	DWORD ImageDataSize;
	WORD  ImageOrgX;
	WORD  ImageOrgY;
	WORD  ImageWidth;
	WORD  ImageHeight;
} TIMLINEARHEADER;



void DeleteTim(TIM* tim);