// TIMmay.cpp : Defines the entry point for the console application.
//

#include "stdafx.h"
#include <cstdlib>
#include "Extract.h"
#include "TIM.h"
#include "Insert.h"

using namespace std;

#define Usage() \
	printf("Usage:\n" \
		   "  Extract:\n" \
		   "    %s e TargetFile\n" \
		   "    %s e TargetFile FirstToDump LastToDump\n" \
		   "  Insert:\n" \
		   "    %s i TargetFile BuildLog\n\n" , argv[0], argv[0], argv[0]);

int _tmain(int argc, _TCHAR* argv[])
{
	printf("TIMmay v0.3 by Klarth\n");
	if(argc < 3 || argc > 5)
	{
		Usage();
		return 1;
	}

	if(strcmp(argv[1], "e") == 0) // Extract
	{
		if(argc != 3 && argc != 5)
		{
			Usage();
			return 1;
		}

		unsigned int Start = 0;
		unsigned int End = -1;
		unsigned int extracted;
		if(argc == 5) // First/Last specified
		{
			Start = strtoul(argv[3], NULL, 10);
			End   = strtoul(argv[4], NULL, 10);
		}
		if(ExtractTIMs(argv[2], Start, End, extracted))
			printf("Extracted %u TIMs from %s\n", extracted, argv[2]);
		else
			printf("Could not open file %s for reading\n", argv[2]);
	}
	else if(strcmp(argv[1], "i") == 0) // Insert
	{
		if(argc != 4)
		{
			Usage();
			return 1;
		}

		unsigned int inserted;
		unsigned int ret = InsertTIMs(argv[2], argv[3], inserted);
		if(ret == 0)
			printf("Successfully inserted %u TIMs\n", inserted);
		else if(ret == -1)
			printf("Could not open target file %s\n", argv[2]);
		else if(ret == -2)
			printf("Could not open build file %s\n", argv[3]);
	}
	else // Unknown switch
	{
		printf("Unrecognized switch\n");
	}

	return 0;
}